function [basal,prism1,pyram,sum1] = import_slipsystemacts(filename, startRow, endRow)
%IMPORTFILE1 Import numeric data from a text file as column vectors.
%   [BASAL,PRISM1,PYRAM,SUM1] = IMPORTFILE1(FILENAME) Reads data from text
%   file FILENAME for the default selection.
%
%   [BASAL,PRISM1,PYRAM,SUM1] = IMPORTFILE1(FILENAME, STARTROW, ENDROW)
%   Reads data from rows STARTROW through ENDROW of text file FILENAME.
%
% Example:
%   [basal,prism1,pyram,sum1] =
%   importfile1('fraction00rate10_newgrid_MeanSlipSysAct.txt',1, 75);
%
%    See also TEXTSCAN.

% Auto-generated by MATLAB on 2015/10/01 12:05:13

%% Initialize variables.
delimiter = ' ';
if nargin<=2
    startRow = 1;
    endRow = inf;
end

%% Format string for each line of text:
%   column5: double (%f)
%	column6: double (%f)
%   column7: double (%f)
%	column8: double (%f)
% For more information, see the TEXTSCAN documentation.
formatSpec = '%*s%*s%*s%*s%f%f%f%f%[^\n\r]';

%% Open the text file.
fileID = fopen(filename,'r');

%% Read columns of data according to format string.
% This call is based on the structure of the file used to generate this
% code. If an error occurs for a different file, try regenerating the code
% from the Import Tool.
dataArray = textscan(fileID, formatSpec, endRow(1)-startRow(1)+1, 'Delimiter', delimiter, 'MultipleDelimsAsOne', true, 'HeaderLines', startRow(1)-1, 'ReturnOnError', false);
for block=2:length(startRow)
    frewind(fileID);
    dataArrayBlock = textscan(fileID, formatSpec, endRow(block)-startRow(block)+1, 'Delimiter', delimiter, 'MultipleDelimsAsOne', true, 'HeaderLines', startRow(block)-1, 'ReturnOnError', false);
    for col=1:length(dataArray)
        dataArray{col} = [dataArray{col};dataArrayBlock{col}];
    end
end

%% Close the text file.
fclose(fileID);

%% Post processing for unimportable data.
% No unimportable data rules were applied during the import, so no post
% processing code is included. To generate code which works for
% unimportable data, select unimportable cells in a file and regenerate the
% script.

%% Allocate imported array to column variable names
basal = dataArray{:, 1};
prism1 = dataArray{:, 2};
pyram = dataArray{:, 3};
sum1 = dataArray{:, 4};


